//+------------------------------------------------------------------+
//|                                                    e-ASClose.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|   23.11.2005     ASCTrend.                           |
//|              |
//|  .     ,     |
//|  .                                        |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

//-------    --------------------------------
extern string _Parameters_Trade = "-----  ";
extern double Lots        = 1;    //   
extern int    Slippage    = 3;      //  
extern int    NumberOfTry = 5;      //  

//-------    ---------------------------------
#include <s-SilverTrend_Signal.mqh>
#include <stdlib.mqh>
//
extern string _Parameters_Expert = "-----  ";
extern int    MAGIC         = 20051123;
extern string Name_Expert   = "e-ASClose";
extern bool   UseSound      = False;        //   
extern string NameFileSound = "expert.wav"; //   
extern color  clOpenBuy     = LightBlue;    //   
extern color  clOpenSell    = LightCoral;   //   
extern color  clModifyBuy   = Aqua;         //   
extern color  clModifySell  = Tomato;       //   
extern color  clCloseBuy    = Blue;         //   
extern color  clCloseSell   = Red;          //   
#include <b-SimpleTrailing.mqh>

//----    -------------------------------
int prevTimeBar;

void deinit() { Comment(""); }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {
if (UseTrailing) TrailingPositions();
/*  if (prevTimeBar!=Time[0]) */OpenPosition();
//  prevTimeBar=Time[0];
}

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OpenPosition() {
  double ldStop=0, ldTake=0, ms[2]={EMPTY_VALUE, EMPTY_VALUE};
   
  GetSignals("", 0, 1, ms);

  if (ms[0]!=EMPTY_VALUE) {
    if (ExistPos(OP_SELL)) CloseAllPositions();
    if (!ExistPos(OP_BUY)) {
      ldStop=ms[0];
      SetOrder(OP_BUY, Ask, ldStop, ldTake);
    }
  }
  if (ms[1]!=EMPTY_VALUE) {
    if (ExistPos(OP_BUY)) CloseAllPositions();
    if (!ExistPos(OP_SELL)) {
      ldStop=ms[1];
      SetOrder(OP_SELL, Bid, ldStop, ldTake);
    }
  }
}

//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
bool ExistPos(int op) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==op) { Exist=True; break; }
      }
    }
  }
  return(Exist);
}

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   pp     -                                                   |
//|   ldStop -                                            |
//|   ldTake -                                            |
//+------------------------------------------------------------------+
void SetOrder(int op, double pp, double ldStop, double ldTake) {
  color  clOpen;
  int    err, ticket=0;
  string lsComm=GetCommentForOrder();

  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  for (int i=0; i<NumberOfTry; i++) {
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    ticket=OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(NameFileSound); break;
    } else {
      err=GetLastError();
      Print("Error(",err,") opening order: ",ErrorDescription(err));
      Sleep(5000);
    }
  }
}

//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
string GetCommentForOrder() {
  return(Name_Expert+" "+GetNameTF(Period()));
}

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
string GetNameTF(int TimeFrame) {
	switch (TimeFrame) {
		case PERIOD_MN1: return("Monthly");
		case PERIOD_W1:  return("Weekly");
		case PERIOD_D1:  return("Daily");
		case PERIOD_H4:  return("H4");
		case PERIOD_H1:  return("H1");
		case PERIOD_M30: return("M30");
		case PERIOD_M15: return("M15");
		case PERIOD_M5:  return("M5");
		case PERIOD_M1:  return("M1");
		default:		     return("UnknownPeriod");
	}
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void CloseAllPositions() {
  bool fc;
  int  err, it;

  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        fc=False;
        for (it=0; it<NumberOfTry; it++) {
          while (!IsTradeAllowed()) Sleep(5000);
          if (OrderType()==OP_BUY) {
            fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
          }
          if (OrderType()==OP_SELL) {
            fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
          }
          if (fc) {
            if (UseSound) PlaySound(NameFileSound); break;
          } else {
            err=GetLastError();
            Print("Error(",err,") closing order: ",ErrorDescription(err));
            Sleep(5000);
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+

